var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import './shims.js';
// 0SERVER gets replaced by real import during build
// eslint-disable-next-line @typescript-eslint/ban-ts-comment
// @ts-ignore
import { Server } from '0SERVER';
export function init(manifest) {
    const server = new Server(manifest);
    let initPromise = server.init({
        env: process.env,
    });
    return (req, res) => __awaiter(this, void 0, void 0, function* () {
        if (initPromise !== null) {
            yield initPromise;
            initPromise = null;
        }
        let request;
        try {
            request = isGetOrPatchRequest(req.method)
                ? new Request(getOrigin(req.headers) + req.url, {
                    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                    // @ts-expect-error
                    duplex: 'half',
                    method: req.method,
                    headers: req.headers,
                })
                : new Request(getOrigin(req.headers) + req.url, {
                    // eslint-disable-next-line @typescript-eslint/ban-ts-comment
                    // @ts-expect-error
                    duplex: 'half',
                    method: req.method,
                    headers: req.headers,
                    body: req.body,
                });
        }
        catch (err) {
            res.statusCode = err.status || 400;
            res.end('Invalid request body');
            return;
        }
        const rendered = yield server.respond(request);
        const body = yield rendered.text();
        return rendered
            ? res
                .writeHead(rendered.status, Object.fromEntries(rendered.headers))
                .end(body)
            : res.writeHead(404, 'Not Found').end();
    });
}
function isGetOrPatchRequest(method) {
    return ['GET', 'PATCH'].includes(method);
}
function getOrigin(headers) {
    const protocol = 'https';
    const host = headers['host'];
    return `${protocol}://${host}`;
}
//# sourceMappingURL=function.js.map